/* declarations */
%{
#include <stdio.h>
#include <strings.h>
#include "y.tab.h"

/*
  Changed underscores in tags to hyphens
*/

%}

        extern int lineno;
/*        extern char yytext[]; /* when using lex */
        extern char *yytext; /* when using lex */
        lineno = 1;

/* rules */
%%

"<CCC>"           { return(CCC); }
"</CCC>"          { return(endCCC); }

"<CCOPY>"           { return(CCOPY); }

"<CIK>"           { return(CIK); }
"</CIK>"          { return(endCIK); }

"<CITY>"           { return(CITY); }
"</CITY>"          { return(endCITY); }

"<DELAMEND>"           { return(DELAMEND); }

"<INCLUDE>"         { return(INCLUDE); }
"</INCLUDE>"         { return(endINCLUDE); }

"<LIVE>"           { return(LIVE); }

"<PRINT>"           { return(PRINT); }

"<R>"           { return(R); }
"</R>"          { return(endR); }

"<STATE>"           { return(STATE); }
"</STATE>"          { return(endSTATE); }

"<STREET1>"           { return(STREET1); }
"</STREET1>"          { return(endSTREET1); }

"<STREET2>"           { return(STREET2); }
"</STREET2>"          { return(endSTREET2); }

"<SUBMISSION>"           { return(SUB); }
"</SUBMISSION>"          { return(endSUB); }

"<TABLE>"       { return(TABLE); }
"</TABLE>"       { return(endTABLE); }

"<TAX-ID>"      { return(TAX_ID); }
"</TAX-ID>"     { return(endTAX_ID); }

"<TEST>"           { return(TEST); }

"<TYPE>"           { return(TYPE); }
"</TYPE>"          { return(endTYPE); }

"<ZIP>"           { return(ZIP); }
"</ZIP>"          { return(endZIP); }

"<REGISTRANT>"           { return(REGISTRANT); }
"</REGISTRANT>"          { return(endREGISTRANT); }

"<FORM>"           { return(FORM); }
"</FORM>"          { return(endFORM); }

"<FILENO>"           { return(FILENO); }
"</FILENO>"          { return(endFILENO); }

"<ACT>"           { return(ACT); }
"</ACT>"          { return(endACT); }

"<NEW-NAME>"           { return(NEW_NAME); }
"</NEW-NAME>"          { return(endNEW_NAME); }

"<NEW-BUS-ADDR>"           { return(NEW_BUS_ADDR); }
"</NEW-BUS-ADDR>"          { return(endNEW_BUS_ADDR); }

"<NEW-MAIL-ADDR>"           { return(NEW_MAIL_ADDR); }
"</NEW-MAIL-ADDR>"          { return(endNEW_MAIL_ADDR); }

"<NEW-PHONE>"           { return(NEW_PHONE); }
"</NEW-PHONE>"          { return(endNEW_PHONE); }

"<NEW-FYEND>"           { return(NEW_FYEND); }
"</NEW-FYEND>"          { return(endNEW_FYEND); }

"<NEW-STATE>"           { return(NEW_STATE); }
"</NEW-STATE>"          { return(endNEW_STATE); }

"<UNITS>"           { return(UNITS); }
"</UNITS>"          { return(endUNITS); }

"<UPRICE>"           { return(UPRICE); }
"</UPRICE>"          { return(endUPRICE); }

"<FEE-PAYMENT>"           { return(FEE_PAYMENT); }
"</FEE-PAYMENT>"          { return(endFEE_PAYMENT); }

"<PAYOR>"           { return(PAYOR); }
"</PAYOR>"          { return(endPAYOR); }

"<CONTACT-NAME>"           { return(CONTACT_NAME); }
"</CONTACT-NAME>"          { return(endCONTACT_NAME); }

"<CONTACT-PHONE>"           { return(CONTACT_PHONE); }
"</CONTACT-PHONE>"          { return(endCONTACT_PHONE); }

"<MODULE-NAME>"           { return(MODULE_NAME); }
"</MODULE-NAME>"          { return(endMODULE_NAME); }

"<PERIOD>"           { return(PERIOD); }
"</PERIOD>"          { return(endPERIOD); }

"<TABLE>"           { return(TABLE); }
"</TABLE>"          { return(endTABLE); }

"<DOCUMENT>"           { return(DOCUMENT); }
"</DOCUMENT>"          { return(endDOCUMENT); }

"<DESCRIP>"           { return(DESCRIP); }
"</DESCRIP>"          { return(endDESCRIP); }

"</>"           { return(null_endtag); }

[\t\ \~\!\"\#\$\%\&\'\(\)\*\+\,\-\.\/A-Za-z0-9\:\;\=\?\@\[\\\]\^\_\`\{\|\}]+\n?  { 
                  makestr(); 
                  if (yytext[yyleng-1] == '\n') lineno++;
                  return(PRINTABLES); }

(\<|\>)+        { makestr(); return(PRINTABLES); }

\n              { lineno++; return(NEWLINE); }

[\001-\037]     { fprintf(stderr, 
"Warning:  illegal character (octal %#o) on line %6d is being ignored.\n",
yytext[0], lineno);}

%%

makestr()
{
  extern YYSTYPE yylval;
  extern int echo_flag;
  extern char *malloc();
  char *b;

  b = malloc(yyleng + 1);
  strncpy(b, yytext, yyleng);
  *(b + yyleng) = '\0';
  yylval.aval.val = b;
  if (echo_flag) fprintf(stdout, "String (length %2d):   %s\n", 
				 strlen(b),b);
}

